/*
 *     Created by Dionis Beqiraj on 10/08/2022, 16:42
 *     dbeqiraj.sohoal@gmail.com
 *     Last modified 10/08/2022, 16:41
 *     Copyright (c) 2022.
 *     All rights reserved.
 */

package com.dbeqiraj.annotiations_processor.paginate.remotekeydao

class RemoteKeyDaoBuilder(
    className: String,
    entityName: String,
    packageName: String
) {
    private val contentTemplate = """
        package $packageName
        
        import androidx.room.Dao
        import androidx.room.Insert
        import androidx.room.OnConflictStrategy
        import androidx.room.Query
        
        /**
        * Autogenerated
        */
        @Dao
        interface $className {
            @Insert(onConflict = OnConflictStrategy.REPLACE)
            suspend fun insertAll(remoteKey: List<$entityName>)
        
            @Query("SELECT * FROM $entityName WHERE id = :id")
            suspend fun remoteKeysById(id: Int): $entityName?
        
            @Query("DELETE FROM $entityName")
            suspend fun deleteAll()
        }
        
    """.trimIndent()

    fun getContent(): String {
        return contentTemplate
    }
}
